<%@ Page Language="VB" ResponseEncoding="iso-8859-1" Debug="true" %>
<%@ Register TagPrefix="Rico" Assembly="Rico" NameSpace="Rico" %>
<%@ Register TagPrefix="My" TagName="dbLib" Src="dbConnect.ascx" %>
<My:dbLib id='app' runat='server' />

<script runat="server">

Sub Page_Load(Sender As object, e As EventArgs)
  dim category,lastCategory,Discounts,Gross,subtotals(1),grandtotals(1),i
  dim command,rdr

  if not app.OpenDB() then exit sub
  
  for i=0 to 1
    grandtotals(i)=0
  next

  command = app.dbConnection.CreateCommand()
  command.CommandText="select CategoryName,ProductName, " & _
    "SUM(od.UnitPrice*Quantity) as GrossSales, " & _
    "SUM(od.UnitPrice*Quantity*Discount) as Discounts " & _
    "from ((Order_Details od " & _
    "inner join Products p on p.ProductID=od.ProductID) " & _
    "inner join Categories c on p.CategoryID=c.CategoryID) " & _
    "group by CategoryName,ProductName " & _
    "order by CategoryName,ProductName"
  rdr = command.ExecuteReader()
  while rdr.Read()
    category=rdr("CategoryName")
    Gross=rdr("GrossSales")
    Discounts=rdr("Discounts")
    if category<>lastCategory then
      if not IsNothing(lastCategory) then
        AddRow("Subtotal",subtotals(0),subtotals(1),"Subtotal")
      end if
      ex1.AddDataRow
      ex1.AddCell(new SimpleGrid.TextCell(category, "CatHead"))
      ex1.AddCell(new SimpleGrid.TextCell("", "CatHead"))
      ex1.AddCell(new SimpleGrid.TextCell("", "CatHead"))
      ex1.AddCell(new SimpleGrid.TextCell("", "CatHead"))
      ex1.AddCell(new SimpleGrid.TextCell("", "CatHead"))
      for i=0 to 1
        subtotals(i)=0
      next
      lastCategory=category
    end if
    subtotals(0)+=Gross
    grandtotals(0)+=Gross
    subtotals(1)+=Discounts
    grandtotals(1)+=Discounts
    AddRow(rdr("ProductName"),Gross,Discounts,"")
  end while
  rdr.Close()
  if not IsNothing(lastCategory) then
    AddRow("Subtotal",subtotals(0),subtotals(1),"Subtotal")
  end if
  AddRow("Grand Total",grandtotals(0),grandtotals(1),"GrandTotal")
End Sub

sub AddRow(ProductName as String, Gross as Double, Discounts as Double, StyleId as String)
  dim pct as double
  ex1.AddDataRow()
  ex1.AddCell(new SimpleGrid.TextCell(ProductName, StyleId))
  ex1.AddCell(new SimpleGrid.NumberCell(Gross, StyleId & "Number"))
  ex1.AddCell(new SimpleGrid.NumberCell(Discounts, StyleId & "Number"))
  ex1.AddCell(new SimpleGrid.NumberCell(Gross-Discounts, StyleId & "Number"))
  pct=Discounts/Gross
  ex1.AddCell(new SimpleGrid.NumberCell(pct, StyleId & "Percent"))
end sub

Protected Overrides Sub Render(writer as HTMLTextWriter)
  select case lcase(Request.QueryString("fmt"))
    case "xl":  ex1.RenderExcel("ProductSalesSummary.xml")
    case "csv": ex1.RenderDelimited("ProductSalesSummary.csv")
    case else:  MyBase.Render(writer)   ' output html
  end select
End Sub

</script>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html>
<head>
<title>Rico SimpleGrid-Example 1</title>

<Rico:LoadClient checkQueryString='notheme' runat='server' />
<link href="../demo.css" type="text/css" rel="stylesheet" />


<script type='text/javascript'>
function ExportGridClient() {
  ex1['grid'].printVisible();
}

function ExportGridServer(ExportType) {
  if (Rico.isIE) {
    location.href+='&fmt='+ExportType;
  } else {
    window.open(location.href+'&fmt='+ExportType);
  }
}
</script>

</head>

<body>

<div id='explanation'>
Base Library: 
<script type='text/javascript'>
document.write(Rico.Lib+' '+Rico.LibVersion);
</script>
<hr>
<p><strong>Rico: SimpleGrid with custom headings/no theme</strong></p>
<p>Rico's SimpleGrid is an unbuffered grid - all data exists in the DOM.
It shares many of the same characteristics as Rico's better known LiveGrid.
SimpleGrids have resizable columns, frozen columns on the left, and can use the
same CSS styling as LiveGrids. Sorting and filtering can also be enabled
at the developer's discretion. Unlike LiveGrids, each cell in a SimpleGrid
can be formatted individually.
</div>


<div>
<button onclick="ExportGridClient()">Export from client<br>to HTML Table</button>
<button onclick="ExportGridServer('xl')">Export from server<br>to Excel</button>
<button onclick="ExportGridServer('csv')">Export from server<br>to CSV</button>
</div>

<Rico:SimpleGrid runat='server' id='ex1' frozenColumns='1' HdgRowLines='2'>
  <Rico:Style runat='server' StyleID='DefaultHdg' BackColor="black" ForeColor="white" HorizontalAlign="center" Bold="true" />
  <Rico:Style runat='server' StyleID='CatHead' BackColor="blue" ForeColor="white" bold="true" />
  <Rico:Style runat='server' StyleID='Subtotal' BackColor="#888888" ForeColor="white" bold="true" />
  <Rico:Style runat='server' StyleID='GrandTotal' BackColor="black" ForeColor="white" bold="true" />
  <Rico:Style runat='server' StyleID='Number' NumberFormat="$#,##0" HorizontalAlign="right" />
  <Rico:Style runat='server' StyleID='SubtotalNumber' NumberFormat="$#,##0" HorizontalAlign="right" BackColor="#888888" ForeColor="white" bold="true" />
  <Rico:Style runat='server' StyleID='GrandTotalNumber' NumberFormat="$#,##0" HorizontalAlign="right" BackColor="black" ForeColor="white" bold="true" />
  <Rico:Style runat='server' StyleID='Percent' NumberFormat="0%" HorizontalAlign="right" />
  <Rico:Style runat='server' StyleID='SubtotalPercent' NumberFormat="0%" HorizontalAlign="right" BackColor="#888888" ForeColor="white" bold="true" />
  <Rico:Style runat='server' StyleID='GrandTotalPercent' NumberFormat="0%" HorizontalAlign="right" BackColor="black" ForeColor="white" bold="true" />

  <Rico:SimpleCol runat='server' heading="Product" width='200' />
  <Rico:SimpleCol runat='server' heading="Gross Sales" />
  <Rico:SimpleCol runat='server' heading="Discounts" />
  <Rico:SimpleCol runat='server' heading="Net Sales" />
  <Rico:SimpleCol runat='server' heading="Avg Discount" width='65' />
</Rico:SimpleGrid>

</body>
</html>
