﻿<%@ Page Language="VB" ResponseEncoding="utf-8" Debug="true" %>
<%@ Register TagPrefix="Rico" Assembly="Rico" NameSpace="Rico" %>
<%@ Register TagPrefix="My" TagName="dbLib" Src="dbConnect.ascx" %>
<My:dbLib id='app' runat='server' />

<script runat="server">

Sub Page_Load(Sender As object, e As EventArgs)
  
  Dim d1 as new DateTime(2010,1,6,5,47,3)
  Dim d2 as new DateTime(2010,6,15,10,15,0)
  Dim d3 as new DateTime(2010,12,25,20,5,33)
  Dim keys As ICollection = NumberFormats.Styles.Keys
  Dim keysArray(keys.Count - 1) As String
  keys.CopyTo(keysArray, 0)
  Array.Sort(keysArray)
  Dim s As Rico.Style
  For Each key As String in KeysArray
      s = NumberFormats.Styles(key)
      if not String.IsNullOrEmpty(s.NumberFormat) then
          NumberFormats.AddDataRow
          NumberFormats.AddCell(new SimpleGrid.TextCell(s.NumberFormat))
          select case left(s.StyleId,3)
            case "Num":
              NumberFormats.AddCell(new SimpleGrid.NumberCell(1234567.89, s.StyleId))
              NumberFormats.AddCell(new SimpleGrid.NumberCell(-12345.6789, s.StyleId))
              NumberFormats.AddCell(new SimpleGrid.NumberCell(0, s.StyleId))
            case "Tel":
              NumberFormats.AddCell(new SimpleGrid.NumberCell(9035551212, s.StyleId))
              NumberFormats.AddCell(new SimpleGrid.NumberCell(2015551212, s.StyleId))
              NumberFormats.AddCell(new SimpleGrid.NumberCell(2145551212, s.StyleId))
            case "Per":
              NumberFormats.AddCell(new SimpleGrid.NumberCell(0.89, s.StyleId))
              NumberFormats.AddCell(new SimpleGrid.NumberCell(-0.6789, s.StyleId))
              NumberFormats.AddCell(new SimpleGrid.NumberCell(0, s.StyleId))
            case "Dat":
              NumberFormats.AddCell(new SimpleGrid.DateTimeCell(d1, s.StyleId))
              NumberFormats.AddCell(new SimpleGrid.DateTimeCell(d2, s.StyleId))
              NumberFormats.AddCell(new SimpleGrid.DateTimeCell(d3, s.StyleId))
          end select
      end if
  Next

End Sub

Protected Overrides Sub Render(writer as HTMLTextWriter)
  select case lcase(Request.QueryString("fmt"))
    case "xl":  NumberFormats.RenderExcel("NumberAndDateFormats.xml")
    case "csv": NumberFormats.RenderDelimited("NumberAndDateFormats.csv")
    case else:  MyBase.Render(writer)   ' output html
  end select
End Sub

</script>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html>
<head>
<title>Rico SimpleGrid-Number Formats</title>

<Rico:LoadClient checkQueryString='true' runat='server' />
<link href="../demo.css" type="text/css" rel="stylesheet" />


<script type='text/javascript'>
function ExportGridClient() {
  NumberFormats['grid'].printVisible();
}

function ExportGridServer(ExportType) {
  if (Rico.isIE) {
    location.href+='&fmt='+ExportType;
  } else {
    window.open(location.href+'&fmt='+ExportType);
  }
}
</script>

</head>

<body>

<div id='explanation'>
Base Library: 
<script type='text/javascript'>
document.write(Rico.Lib+' '+Rico.LibVersion);
</script>
<hr>
<p><strong>Rico: SimpleGrid</strong></p>
<p>In Simple Grids, NumberFormat can be part of the SimpleStyle declaration and the format gets applied to cells of type DateTimeCell and NumberCell. 
This example shows how the various formats get applied to dates and numbers -- and demonstrates how they match the formats exported to Excel.</p>
<p>The formats generally follow the rules for Excel custom formats, with the following exceptions:
<ul>
<li>Months must be upper case (M, MM, MMM, MMMM)
<li>Hours in 12-hour format must be lower case (h, hh) and include the "AM/PM" designator. 
    Hours in 24-hour format must be upper case (H, HH) and must not include the "AM/PM" designator.
<li>Nothing involving square brackets [] is supported (colors, ranges, etc). These formatting characters are also not supported: _ * ? @ /
</ul>
</div>


<div>
<button onclick="ExportGridClient()">Export from client<br>to HTML Table</button>
<button onclick="ExportGridServer('xl')">Export from server<br>to Excel</button>
<button onclick="ExportGridServer('csv')">Export from server<br>to CSV</button>
</div>

<Rico:SimpleGrid runat='server' id='NumberFormats' frozenColumns='1'>
  <Rico:Style runat='server' StyleID='Number01' NumberFormat="$#,##0" HorizontalAlign="right" />
  <Rico:Style runat='server' StyleID='Number02' NumberFormat="€#,##0.00" HorizontalAlign="right" />
  <Rico:Style runat='server' StyleID='Number03' NumberFormat="¥#,##0.00" HorizontalAlign="right" />
  <Rico:Style runat='server' StyleID='Number04' NumberFormat="0" HorizontalAlign="right" />
  <Rico:Style runat='server' StyleID='Number05' NumberFormat="0.000" HorizontalAlign="right" />
  <Rico:Style runat='server' StyleID='Number06' NumberFormat="#,##0,K" HorizontalAlign="right" />
  <Rico:Style runat='server' StyleID='Number07' NumberFormat="0,,.000\M" HorizontalAlign="right" />
  <Rico:Style runat='server' StyleID='Number08' NumberFormat='#,##0 "Dollars and" .00 "Cents"' HorizontalAlign="right" />
  <Rico:Style runat='server' StyleID='Number09' NumberFormat='0.###E+0' HorizontalAlign="right" />
  <Rico:Style runat='server' StyleID='Number10' NumberFormat='0.###E+000' HorizontalAlign="right" />
  <Rico:Style runat='server' StyleID='Number11' NumberFormat='0.00 ;(-0.00)' HorizontalAlign="right" />
  <Rico:Style runat='server' StyleID='Number12' NumberFormat='#;(#);"**Zero**"' HorizontalAlign="right" />
  <Rico:Style runat='server' StyleID='Telephone' NumberFormat='(###) ###-####' HorizontalAlign="right" />
  <Rico:Style runat='server' StyleID='Percent1' NumberFormat="0%" HorizontalAlign="right" />
  <Rico:Style runat='server' StyleID='Percent2' NumberFormat="0.0%" HorizontalAlign="right" />
  <Rico:Style runat='server' StyleID='Percent3' NumberFormat="0.#%" HorizontalAlign="right" />

  <Rico:Style runat='server' StyleID='Date0' NumberFormat='yyyyMMdd' />
  <Rico:Style runat='server' StyleID='Date1' NumberFormat='dddd d-M-yyyy' />
  <Rico:Style runat='server' StyleID='Date2' NumberFormat='ddd MMMM d yyyy' />
  <Rico:Style runat='server' StyleID='Date3' NumberFormat='HHmm' />
  <Rico:Style runat='server' StyleID='Date4' NumberFormat='HHmm "hrs"' />
  <Rico:Style runat='server' StyleID='Date5' NumberFormat='HH "hours and" mm "minutes"' />
  <Rico:Style runat='server' StyleID='Date6' NumberFormat='h:mm AM/PM' />
  <Rico:Style runat='server' StyleID='Date7' NumberFormat='d MMM yyyy HH:mm' />
  <Rico:Style runat='server' StyleID='Date8' NumberFormat='MM/dd/yy hh:mm:ss am/pm' />

  <Rico:SimpleCol runat='server' heading="Format" width='200' />
  <Rico:SimpleCol runat='server' heading="Example 1" width='200' />
  <Rico:SimpleCol runat='server' heading="Example 2" width='200' />
  <Rico:SimpleCol runat='server' heading="Example 3" width='200' />
</Rico:SimpleGrid>

</body>
</html>
